SystemOrganization addCategory: #'UCA-Calendario'!

Object subclass: #Calendario
	instanceVariableNames: 'diasNoLaborables diasParticularesNoLaborables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:39'!
agregarFeriadoAnio: unAnio Mes: unMes Dia: unDia	
	|unaFecha|

	unaFecha:= FechaConAnioMesYDia  conAnio: unAnio conMes: unMes conDia: unDia.
	diasParticularesNoLaborables add: unaFecha.! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:34'!
agregarFeriadoMes: unMes Dia: unDia 
	|unaFecha|

	unaFecha:= FechaConMesYDia  conMes: unMes conDia: unDia.
	diasNoLaborables add: unaFecha.! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:16'!
esFeriadoDiaMes: unDia
	^ (diasNoLaborables anySatisfy: [ :each | each diaEs: (unDia dayOfMonth) mesEs:  (unDia monthIndex)])! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:29'!
esLaborable: unDia
	^ (self esSabadoODomingo: unDia) & (((self esFeriadoDiaMes: unDia )not))! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:01'!
esSabadoODomingo: unDia
	^ unDia dayOfWeek > 1 & (unDia dayOfWeek < 7)! !

!Calendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:39'!
initialize
	diasNoLaborables:=OrderedCollection new.
	diasParticularesNoLaborables:= OrderedCollection new.! !

Object subclass: #FechaConAnioMesYDia
	instanceVariableNames: 'dia mes anio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!FechaConAnioMesYDia class methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:37'!
conAnio: unAnio conMes: unMes conDia: unDia
	^self new inicializarConAnio: unAnio conMes: unMes conDia: unDia! !

!FechaConAnioMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:37'!
inicializarConAnio:unAnio conMes: unMes conDia: unDia
	anio:=unAnio.
	mes:=unMes.
	dia:=unDia! !

Object subclass: #FechaConMesYDia
	instanceVariableNames: 'dia mes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!FechaConMesYDia class methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:30'!
conMes: unMes conDia: unDia
	^self new inicializarConMes: unMes conDia: unDia! !

!FechaConMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:24'!
diaEs:unDia mesEs:unMes
	^(dia=unDia & mes=unMes)! !

!FechaConMesYDia methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:30'!
inicializarConMes: unMes conDia: unDia
	mes:=unMes.
	dia:=unDia! !

TestCase subclass: #TestCalendario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'UCA-Calendario'!

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 19:53'!
test01DadoUnDiaDomingoNoEsLaborable
	|dia28oct2012 unCalendario|

	dia28oct2012:=Date year: 2012 month:  10 day: 28. 
	unCalendario:= Calendario new.
	
	self deny: ( unCalendario esLaborable: dia28oct2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:19'!
test02DadoUnDiaLunesNoEsLaborable
	|dia29oct2012 unCalendario|

	dia29oct2012:=Date year: 2012 month:  10 day: 29. 
	unCalendario:= Calendario new.
	
	self assert: ( unCalendario esLaborable: dia29oct2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 20:19'!
test03DadoUnDia25DeDiciembreEsFeriado
	|dia25dic2012 unCalendario|

	dia25dic2012:=Date year: 2012 month:12 day: 25. 
	unCalendario:= Calendario new.
	unCalendario agregarFeriadoMes: 12 Dia: 25.	
	
	self deny: ( unCalendario esLaborable: dia25dic2012)! !

!TestCalendario methodsFor: 'as yet unclassified' stamp: 'RU 10/30/2012 21:37'!
test04DadoUnDiaEnParticularSaberSiEsFeriado
	|dia25sept1981 unCalendario|

	dia25sept1981:=Date year: 2012 month:9 day: 25. 
	unCalendario:= Calendario new.
	unCalendario agregarFeriadoAnio: 1987 Mes: 12 Dia: 25.	
	
	self deny: ( unCalendario esLaborable: dia25sept1981)! !
